## digikam 8.5.0

=== CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024, Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

set(CMAKE_MIN_VERSION   "3.16")

cmake_minimum_required(VERSION ${CMAKE_MIN_VERSION})

message(STATUS "CMake version: ${CMAKE_VERSION}")

# ==============================================================================
# Information to update before to release this package.

# digiKam version
set(DIGIKAM_MAJOR_VERSION "8")
set(DIGIKAM_MINOR_VERSION "5")
set(DIGIKAM_PATCH_VERSION "0")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final release. Can be used in production.
set(DIGIKAM_SUFFIX_VERSION "")

# ==============================================================================
# Set env. variables accordingly.

# NOTE: This string is used to set libdigikamcore and libdigikamdatabase SO version ID
set(DIGIKAM_VERSION_SHORT
    "${DIGIKAM_MAJOR_VERSION}.${DIGIKAM_MINOR_VERSION}.${DIGIKAM_PATCH_VERSION}"
)

set(DIGIKAM_VERSION_STRING
    "${DIGIKAM_VERSION_SHORT}${DIGIKAM_SUFFIX_VERSION}"
)

# Core Database XML version
# We must set this variable here at top level because it is used in both
# libs/database/core and data/database
# Version history:
# 1 : Original database XML file, published in production.
# 2 : 08-08-2014 : Fix Images.names field size (see bug #327646).
# 3 : 05/11/2015 : Add Face DB schema.
set(DBCORECONFIG_XML_VERSION "3")

# ==============================================================================

project(digikam
        VERSION ${DIGIKAM_VERSION_SHORT}
        LANGUAGES CXX C)

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Starting CMake configuration for ${PROJECT_NAME}")
message(STATUS "")
message(STATUS "Target Build Type: ${CMAKE_BUILD_TYPE}")

# Extra check to detect Qt core with minimal version before to continue.

set(QT5_MIN_VERSION       "5.14.0")
set(QT6_MIN_VERSION       "6.4.0")
set(CMAKE_MODULE_PATH 
                      ${CMAKE_SOURCE_DIR}/core/cmake/modules
                      ${CMAKE_SOURCE_DIR}/core/cmake/macros
                      ${CMAKE_SOURCE_DIR}/core/cmake/rules
)

# Must be done before ECM checks.

include(RulesFindQtCore)

if(Qt6_FOUND)
    set(ECM_MIN_VERSION "5.240.0")
else()
    set(ECM_MIN_VERSION "5.55.0")
endif()

if ("${QT_VERSION}" VERSION_GREATER 6.6.99)
    set(CMAKE_CXX_STANDARD      20)
else()
    set(CMAKE_CXX_STANDARD      17)
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS        OFF)

### ECM setup #########################################################################################################

find_package(ECM ${ECM_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
                      ${ECM_MODULE_PATH}
)

# KDE Framework macros
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
remove_definitions(-DQT_NO_FOREACH)

# ECM macros
include(ECMSetupVersion)
include(ECMOptionalAddSubdirectory)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMPoQmTools)
include(ECMAddTests)
include(ECMMarkAsTest)

# Cmake macros
include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
include(CheckFunctionExists)
include(FeatureSummary)

# Local macros
include(MacroUtils)
include(MacroCompiler)
include(MacroOpenCV)
include(MacroJPEG)
include(MacroBoolTo01)

#######################################################################################################################

APPLY_COMMON_POLICIES()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC ON)
#set(CMAKE_AUTOUIC ON)
#set(CMAKE_AUTORCC ON)

if(MSVC)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /permissive-")
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY AUTOGEN_TARGETS_FOLDER "Generated")

### COMPILATION OPTIONS MANAGEMENT ####################################################################################

option(DIGIKAMSC_COMPILE_PO              "Build translations files (default=ON)"                                                  ON)
option(DIGIKAMSC_COMPILE_DIGIKAM         "Build digiKam core (default=ON)"                                                        ON)

#######################################################################################################################

if(DIGIKAMSC_COMPILE_PO AND NOT MSVC)
    set_property(GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS 1)
endif()

if(BUILD_TESTING)
    include(CTest)
endif()

######################################################################################################################

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Top level compilation configuration for ${PROJECT_NAME}")
message(STATUS "")

if(DIGIKAMSC_COMPILE_DIGIKAM)
    if(NOT EXISTS ${CMAKE_SOURCE_DIR}/core)
        message(STATUS "${PROJECT_NAME} will be compiled....................... NO (source code not available)")
        set (DIGIKAMSC_COMPILE_DIGIKAM OFF)
    else()
        message(STATUS "${PROJECT_NAME} will be compiled....................... YES")
    endif()
else()
    message(STATUS     "${PROJECT_NAME} will be compiled....................... NO")
endif()

if(DIGIKAMSC_COMPILE_PO)
    message(STATUS "Translations will be compiled.................. YES")
else()
    message(STATUS "Translations will be compiled.................. NO")
endif()

if(BUILD_TESTING)
    message(STATUS "Tests code will be compiled.................... YES")
else()
    message(STATUS "Tests code will be compiled.................... NO")
endif()

######################################################################################################################

if(DIGIKAMSC_COMPILE_DIGIKAM)
    add_subdirectory(core)
endif()

if(DIGIKAMSC_COMPILE_PO)
    find_package(Gettext REQUIRED)
    find_package(KF${QT_VERSION_MAJOR}I18n NO_MODULE)
    ki18n_install(po)
endif()

if(BUILD_TESTING)

    # Some unit tests require data from the external "Digikam Test Data" git repository.
    # https://invent.kde.org/graphics/digikam-test-data
    #
    # Developers may choose to obtain the data using the "download-repos" script prior to running cmake.
    # For CI runners to run tests, the following custom target serves to perform the download automatically.
    # If the directory "test-data" has already been created, the target becomes a "no-op".
    #
    add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/test-data 
                       COMMENT "Checkout unit-test data repository. Please wait..."
                       COMMAND git
                       ARGS clone https://invent.kde.org/graphics/digikam-test-data.git ${CMAKE_SOURCE_DIR}/test-data)
    add_custom_target(test-data ALL DEPENDS ${CMAKE_SOURCE_DIR}/test-data)

endif()

=== core/app/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

APPLY_COMMON_POLICIES()

# -----------------------------------------------------------------------------------
# Headers to configure

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/utils/digikam_version.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/utils/digikam_version.h)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/utils/digikam_dbconfig.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/utils/digikam_dbconfig.h)

# -----------------------------------------------------------------------------------
# Define common includes rules for digiKam targets

HEADER_DIRECTORIES(${CMAKE_SOURCE_DIR}/core/utilities DK_LOCAL_INCLUDES_UTILS)

set(DIGIKAM_TARGET_INCLUDES $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::PrintSupport,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Gui,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Xml,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Widgets,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Sql,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Network,INTERFACE_INCLUDE_DIRECTORIES>

                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::I18n,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::Solid,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::WindowSystem,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::XmlGui,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::Service,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::CoreAddons,INTERFACE_INCLUDE_DIRECTORIES>

                            ${CMAKE_SOURCE_DIR}/core/app/main
                            ${CMAKE_SOURCE_DIR}/core/app/date
                            ${CMAKE_SOURCE_DIR}/core/app/filters
                            ${CMAKE_SOURCE_DIR}/core/app/dragdrop
                            ${CMAKE_SOURCE_DIR}/core/app/views/stack
                            ${CMAKE_SOURCE_DIR}/core/app/views/utils
                            ${CMAKE_SOURCE_DIR}/core/app/views/sidebar
                            ${CMAKE_SOURCE_DIR}/core/app/views/tableview
                            ${CMAKE_SOURCE_DIR}/core/app/items/utils
                            ${CMAKE_SOURCE_DIR}/core/app/items/thumbbar
                            ${CMAKE_SOURCE_DIR}/core/app/items/delegate
                            ${CMAKE_SOURCE_DIR}/core/app/items/views
                            ${CMAKE_SOURCE_DIR}/core/app/items/overlays
                            ${CMAKE_SOURCE_DIR}/core/app/views/preview

                            ${DK_LOCAL_INCLUDES}
                            ${DK_LOCAL_INCLUDES_UTILS}
)

if(KF${QT_VERSION_MAJOR}IconThemes_FOUND)
    set(DIGIKAM_TARGET_INCLUDES
        ${DIGIKAM_TARGET_INCLUDES}
        $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::IconThemes,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

set(DIGIKAM_TARGET_INCLUDES
    ${DIGIKAM_TARGET_INCLUDES}
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::WebEngineWidgets,INTERFACE_INCLUDE_DIRECTORIES>
)

if(KF${QT_VERSION_MAJOR}KIO_FOUND)
    set(DIGIKAM_TARGET_INCLUDES
        ${DIGIKAM_TARGET_INCLUDES}
        $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::KIOWidgets,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

if(Gphoto2_FOUND)
    set(DIGIKAM_TARGET_INCLUDES
        ${DIGIKAM_TARGET_INCLUDES}
        ${GPHOTO2_INCLUDE_DIRS})
endif()

# -----------------------------------------------------------------------------------
# Targets to build

include(DigikamCoreTarget.cmake)
include(DigikamDatabaseTarget.cmake)
include(DigikamGuiTarget.cmake)
include(DigikamTarget.cmake)

# -----------------------------------------------------------------------------------
# Others Files to install

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/main/org.kde.digikam.desktop     DESTINATION ${KDE_INSTALL_FULL_APPDIR})
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/org.kde.digikam.appdata.xml DESTINATION ${KDE_INSTALL_FULL_METAINFODIR})
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/digikamui5.rc               DESTINATION ${KDE_INSTALL_FULL_KXMLGUIDIR}/digikam)
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/digikam.notifyrc            DESTINATION ${KDE_INSTALL_FULL_KNOTIFYRCDIR})

include(DigikamExportAPI.cmake)

=== core/data/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

add_subdirectory(icons)
add_subdirectory(pics)
add_subdirectory(about)
add_subdirectory(colorschemes)
add_subdirectory(database)
add_subdirectory(geolocation)
add_subdirectory(metadata)
add_subdirectory(profiles)
add_subdirectory(hotplug)
add_subdirectory(scripts)
add_subdirectory(filters)
add_subdirectory(dnnmodels)

if(WIN32)

    add_subdirectory(applications)

endif()

=== core/dplugins/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

HEADER_DIRECTORIES(${CMAKE_SOURCE_DIR}/core/utilities DK_LOCAL_INCLUDES_UTILS)

include_directories(${DK_LOCAL_INCLUDES}
                    ${DK_LOCAL_INCLUDES_UTILS}
)

add_subdirectory(generic)
add_subdirectory(editor)
add_subdirectory(bqm)
add_subdirectory(rawimport)
add_subdirectory(dimg)

=== core/libs/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

# NOTE: include this common rules on top level for DNGWriter and RawEngine.

include(RulesDNGSdk)

HEADER_DIRECTORIES(${CMAKE_SOURCE_DIR}/core/utilities DK_LOCAL_INCLUDES_UTILS)

include_directories(${DK_LOCAL_INCLUDES}
                    ${DK_LOCAL_INCLUDES_UTILS}

                    ${CMAKE_SOURCE_DIR}/core/app/main
                    ${CMAKE_SOURCE_DIR}/core/app/date
                    ${CMAKE_SOURCE_DIR}/core/app/dragdrop
                    ${CMAKE_SOURCE_DIR}/core/app/views/stack
                    ${CMAKE_SOURCE_DIR}/core/app/views/utils
                    ${CMAKE_SOURCE_DIR}/core/app/items/utils
                    ${CMAKE_SOURCE_DIR}/core/app/items/delegate
                    ${CMAKE_SOURCE_DIR}/core/app/views/sidebar
)

add_subdirectory(dimg)
add_subdirectory(dragdrop)
add_subdirectory(metadataengine)
add_subdirectory(database)
add_subdirectory(dtrash)
add_subdirectory(facesengine)
add_subdirectory(iojobs)
add_subdirectory(imgqsort)
add_subdirectory(jpegutils)
add_subdirectory(pgfutils)
add_subdirectory(threadimageio)
add_subdirectory(widgets)
add_subdirectory(properties)
add_subdirectory(progressmanager)
add_subdirectory(threads)
add_subdirectory(versionmanager)
add_subdirectory(networkmanager)
add_subdirectory(notificationmanager)
add_subdirectory(models)
add_subdirectory(onlineversion)
add_subdirectory(template)
add_subdirectory(dialogs)
add_subdirectory(dplugins)
add_subdirectory(fileactionmanager)
add_subdirectory(filters)
add_subdirectory(settings)
add_subdirectory(rawengine)
add_subdirectory(album)
add_subdirectory(tags)
add_subdirectory(transitionmngr)
add_subdirectory(timeadjust)
add_subdirectory(video)
add_subdirectory(dnnmodelmanager)

if(JXL_FOUND)

    add_subdirectory(dngwriter)

endif()

=== core/showfoto/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

APPLY_COMMON_POLICIES()

# To fill MacOS and Windows bundles metadata

set(BUNDLE_APP_NAME_STRING          "showfoto")
set(BUNDLE_APP_DESCRIPTION_STRING   "Stand alone Photo Editor based on digiKam Image Editor")
set(BUNDLE_LEGAL_COPYRIGHT_STRING   "GNU Public License V2")
set(BUNDLE_COMMENT_STRING           "Free and open source software to edit photo")
set(BUNDLE_LONG_VERSION_STRING      ${DIGIKAM_VERSION_STRING})
set(BUNDLE_SHORT_VERSION_STRING     ${DIGIKAM_VERSION_SHORT})
set(BUNDLE_VERSION_STRING           ${DIGIKAM_VERSION_STRING})

# Showfoto executable

set(showfoto_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetuptooltip.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetupmisc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetupmetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetupraw.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetupplugins.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetup.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotoiteminfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotoitemmodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotothumbnailmodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotofiltermodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotodragdrophandler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotokineticscroller.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotoitemsortsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotocoordinatesoverlay.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotoitemviewdelegate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotodelegate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfototooltipfiller.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotocategorizedview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotothumbnailbar.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewsidebar.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewlist.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewmodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewbar.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewundo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewtooltip.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewbookmarks.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewbookmarkdlg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewbookmarklist.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/folderview/showfotofolderviewbookmarkitem.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/stackview/showfotostackviewsidebar.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackview/showfotostackviewlist.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackview/showfotostackviewitem.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackview/showfotostackviewtooltip.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackview/showfotostackviewfavorites.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackview/showfotostackviewfavoriteitemdlg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackview/showfotostackviewfavoritelist.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackview/showfotostackviewfavoriteitem.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfotosettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfotoinfoiface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_open.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_iofiles.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_setup.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_config.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_import.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_thumbbar.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/main.cpp
)

# Set the application icon on the application

file(GLOB ICONS_SRCS "${CMAKE_SOURCE_DIR}/core/data/icons/apps/*-apps-showfoto.png")

if(WIN32)

    # Build the main implementation into a DLL to be called by a stub EXE.
    # This is a work around "command line is too long" issue on Windows.
    # see https://stackoverflow.com/questions/43184251/cmake-command-line-too-long-windows

    add_library(showfoto SHARED ${showfoto_SRCS})
    set_target_properties(showfoto PROPERTIES PREFIX "")

elseif(APPLE)

    ecm_add_app_icon(showfoto_SRCS ICONS ${ICONS_SRCS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/templates/ShowfotoInfo.plist.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
    add_executable(showfoto ${showfoto_SRCS})
    set_target_properties(showfoto PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)

else()

    ecm_add_app_icon(showfoto_SRCS ICONS ${ICONS_SRCS})
    add_executable(showfoto ${showfoto_SRCS})

endif()

HEADER_DIRECTORIES(${CMAKE_SOURCE_DIR}/core/utilities DK_LOCAL_INCLUDES_UTILS)

target_include_directories(showfoto

                           # We need to include the setup dir for showfoto BEFORE the other include dirs,
                           # otherwise the one from the "utilities" dir will be used

                           BEFORE
                           PRIVATE

                           ${CMAKE_CURRENT_SOURCE_DIR}/folderview
                           ${CMAKE_CURRENT_SOURCE_DIR}/stackview
                           ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar
                           ${CMAKE_CURRENT_SOURCE_DIR}/setup
                           ${CMAKE_CURRENT_SOURCE_DIR}/main
)

target_include_directories(showfoto

                           AFTER
                           PRIVATE

                           $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Network,INTERFACE_INCLUDE_DIRECTORIES>

                           ${CMAKE_SOURCE_DIR}/core/app/dragdrop
                           ${CMAKE_SOURCE_DIR}/core/app/items/overlays
                           ${CMAKE_SOURCE_DIR}/core/app/views/sidebar

                           ${DK_LOCAL_INCLUDES}
                           ${DK_LOCAL_INCLUDES_UTILS}
)

if(KF${QT_VERSION_MAJOR}IconThemes_FOUND)

    target_include_directories(showfoto
                               AFTER
                               PRIVATE
                               $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::IconThemes,INTERFACE_INCLUDE_DIRECTORIES>
    )

    if (Qt6_FOUND)

        target_include_directories(showfoto
                                   AFTER
                                   PRIVATE
                                   $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::IconWidgets,INTERFACE_INCLUDE_DIRECTORIES>
        )

    endif()

endif()

add_dependencies(showfoto digikam-gitversion)
add_dependencies(showfoto digikam-builddate)

target_link_libraries(showfoto

                      PUBLIC

                      Qt${QT_VERSION_MAJOR}::Core
                      Qt${QT_VERSION_MAJOR}::Gui
                      Qt${QT_VERSION_MAJOR}::Xml
                      Qt${QT_VERSION_MAJOR}::Widgets

                      KF${QT_VERSION_MAJOR}::XmlGui
                      KF${QT_VERSION_MAJOR}::I18n
                      KF${QT_VERSION_MAJOR}::ConfigCore
                      KF${QT_VERSION_MAJOR}::Service
                      KF${QT_VERSION_MAJOR}::CoreAddons

                      digikamcore
)

if(KF${QT_VERSION_MAJOR}Notifications_FOUND)

    target_link_libraries(showfoto
                          PUBLIC
                          KF${QT_VERSION_MAJOR}::Notifications
    )

endif()

if(KF${QT_VERSION_MAJOR}NotifyConfig_FOUND)

    target_link_libraries(showfoto
                          PUBLIC
                          KF${QT_VERSION_MAJOR}::NotifyConfig
    )

endif()

if(KF${QT_VERSION_MAJOR}IconThemes_FOUND)

    target_link_libraries(showfoto
                          PUBLIC
                          KF${QT_VERSION_MAJOR}::IconThemes
    )

    if (Qt6_FOUND)

        target_link_libraries(showfoto
                              PUBLIC
                              KF${QT_VERSION_MAJOR}::IconWidgets
        )

    endif()

endif()

if(ImageMagick_Magick++_FOUND)

    target_link_libraries(showfoto
                          PUBLIC
                          ${ImageMagick_LIBRARIES}
    )

endif()

if(NOT WIN32)

    # To link under Solaris (see bug #274484)
    target_link_libraries(showfoto
                          PUBLIC
                          ${MATH_LIBRARY}
    )

endif()

if(CMAKE_SYSTEM_NAME STREQUAL FreeBSD)

    target_link_libraries(showfoto
                          PUBLIC
                          ${KVM_LIBRARY}
    )

endif()

if(APPLE)

    target_link_libraries(showfoto
                          PUBLIC
                          /System/Library/Frameworks/AppKit.framework
    )

endif()

if(Qt6_FOUND)
    install(TARGETS showfoto DESTINATION ${KDE_INSTALL_BINDIR})
else()
    install(TARGETS showfoto ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/main/org.kde.showfoto.desktop     DESTINATION ${KDE_INSTALL_FULL_APPDIR})
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/org.kde.showfoto.appdata.xml DESTINATION ${KDE_INSTALL_FULL_METAINFODIR})
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfotoui5.rc               DESTINATION ${KDE_INSTALL_FULL_KXMLGUIDIR}/showfoto)

if(APPLE)
    install(FILES "$<TARGET_FILE:showfoto>.dSYM" DESTINATION "${CMAKE_INSTALL_BINDIR}" CONFIGURATIONS Debug RelWithDebInfo)
endif()

if(WIN32)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/templates/versioninfo.rc.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc)

    set(showfoto_windows_stub_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/main/windows_stub_main.cpp)

    ecm_add_app_icon(showfoto_windows_stub_SRCS ICONS ${ICONS_SRCS})

    add_executable(showfoto_windows_stub_exe
                   ${showfoto_windows_stub_SRCS}
                   ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc
    )

    target_link_libraries(showfoto_windows_stub_exe
                          PRIVATE
                          showfoto)

    if(NOT Qt6_FOUND)

        target_link_libraries(showfoto_windows_stub_exe
                              PRIVATE
                              Qt${QT_VERSION_MAJOR}::WinMain)

    endif()

    set_target_properties(showfoto_windows_stub_exe PROPERTIES OUTPUT_NAME "showfoto")
    target_include_directories(showfoto_windows_stub_exe PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/main)

    install(TARGETS showfoto_windows_stub_exe ${INSTALL_TARGETS_DEFAULT_ARGS})

endif()

if(WIN32)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/templates/showfoto.exe.manifest.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/showfoto.exe.manifest)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/showfoto.exe.manifest DESTINATION ${KDE_INSTALL_BINDIR})

endif()

=== core/tests/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

APPLY_COMMON_POLICIES()

# enabling for everything although only required by DImg.
kde_enable_exceptions()

HEADER_DIRECTORIES(${CMAKE_SOURCE_DIR}/core/utilities DK_LOCAL_INCLUDES_UTILS)

include_directories(${DK_LOCAL_INCLUDES}
                    ${DK_LOCAL_INCLUDES_UTILS}
                    ${CMAKE_CURRENT_SOURCE_DIR}/
)

# -------------------------------------------------------------------------------
# Unit-tests common dependencies

set(_extra_deps ${_extra_deps} Qt${QT_VERSION_MAJOR}::WebEngineWidgets)

if(ENABLE_DBUS)

    set(_extra_deps ${_extra_deps} Qt${QT_VERSION_MAJOR}::DBus)

endif()

if(KF${QT_VERSION_MAJOR}Notifications_FOUND)

    set(_extra_deps ${_extra_deps} KF${QT_VERSION_MAJOR}::Notifications)

endif()

if(Gphoto2_FOUND)

    set(_extra_deps ${_extra_deps} ${GPHOTO2_LIBRARIES})

endif()

if(ImageMagick_Magick++_FOUND)

    set(_extra_deps ${_extra_deps} ${ImageMagick_LIBRARIES})

endif()

if(LensFun_FOUND)

    set(_extra_deps ${_extra_deps} ${LENSFUN_LIBRARIES})

endif()

if(Jasper_FOUND)

    set(_extra_deps ${_extra_deps} ${JASPER_LIBRARIES})

endif()

if(ENABLE_MEDIAPLAYER)

    set(_extra_deps ${_extra_deps} ${MEDIAPLAYER_LIBRARIES})

endif()

if(WIN32)

    set(_extra_deps ${_extra_deps} ws2_32)

endif()

if(NOT WIN32)

    # To link under Solaris (see bug #274484)
    set(_extra_deps ${_extra_deps} ${MATH_LIBRARY})

endif()

if(CMAKE_SYSTEM_NAME STREQUAL FreeBSD)

    set(_extra_deps ${_extra_deps} ${KVM_LIBRARY})

endif()

if(APPLE)

    set(_extra_deps ${_extra_deps} /System/Library/Frameworks/AppKit.framework)

endif()

set(COMMON_TEST_LINK Qt${QT_VERSION_MAJOR}::Core
                     Qt${QT_VERSION_MAJOR}::Gui
                     Qt${QT_VERSION_MAJOR}::Xml
                     Qt${QT_VERSION_MAJOR}::Widgets
                     Qt${QT_VERSION_MAJOR}::Concurrent
                     Qt${QT_VERSION_MAJOR}::Test
                     Qt${QT_VERSION_MAJOR}::Sql

                     KF${QT_VERSION_MAJOR}::XmlGui
                     KF${QT_VERSION_MAJOR}::I18n
                     KF${QT_VERSION_MAJOR}::ConfigCore
                     KF${QT_VERSION_MAJOR}::CoreAddons
                     KF${QT_VERSION_MAJOR}::Service
                     KF${QT_VERSION_MAJOR}::Solid

                     ${OPENMP_LDFLAGS}
                     ${JPEG_LIBRARIES}
                     ${LCMS2_LIBRARIES}
                     ${EXPAT_LIBRARY}
                     ${CMAKE_THREAD_LIBS_INIT}

                     opencv_core
                     opencv_objdetect
                     opencv_imgproc
                     opencv_imgcodecs
                     opencv_dnn
                     opencv_flann

                     ${_extra_deps}
)

# -------------------------------------------------------------------------------
# Common static library for uint-tests based on ModelTest

include_directories(modeltest)

add_library(libmodeltest STATIC
            modeltest/modeltest.cpp
)

target_link_libraries(libmodeltest
                      PRIVATE
                      Qt${QT_VERSION_MAJOR}::Core
                      Qt${QT_VERSION_MAJOR}::Test
)

# -------------------------------------------------------------------------------
# Unit-tests and CLI tools

add_subdirectory(advancedrename)
add_subdirectory(autotagassignment)
add_subdirectory(albummodel)                    # Unit-test based on ModelTest
add_subdirectory(database)                      # Some unit-tests based on ModelTest
add_subdirectory(dimg)
add_subdirectory(dplugins)
add_subdirectory(facesengine)
add_subdirectory(fileio)
add_subdirectory(filters)
add_subdirectory(imgqsort)
add_subdirectory(iojobs)
add_subdirectory(mediaserver)
add_subdirectory(mjpegstream)
add_subdirectory(mediawiki)
add_subdirectory(metadataengine)
add_subdirectory(miscs)
add_subdirectory(multithreading)
add_subdirectory(ocrtextconverter)
add_subdirectory(rawengine)
add_subdirectory(timestampupdate)
add_subdirectory(webservices)
add_subdirectory(widgets)
add_subdirectory(video)

if(JXL_FOUND)

    # DNG support

    add_subdirectory(dngwriter)

endif()

if(ENABLE_GEOLOCATION)

    add_subdirectory(geolocation)               # Some unit-tests based on ModelTest

endif()

if(FLEX_FOUND AND BISON_FOUND AND KF${QT_VERSION_MAJOR}ThreadWeaver_FOUND)

    add_subdirectory(panorama)

endif()

=== core/data/about/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

install(FILES main.html
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/about
)

install(DIRECTORY css/
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/about/css
)

install(DIRECTORY images/
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/about/images
)

install(DIRECTORY js/
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/about/js
)

=== core/data/database/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

# NOTE: the DBCORECONFIG_XML_VERSION ID is configured in the toplevel CMakeLists.txt,
configure_file(dbconfig.xml.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/dbconfig.xml)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dbconfig.xml
              ${CMAKE_CURRENT_SOURCE_DIR}/mysql-global.conf
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/database
)

=== core/data/dnnmodels/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# SPDX-FileCopyrightText: 2024      by Michael Miller, <michael underscore miller at msn dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

install(FILES dnnmodels.conf
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/dnnmodels
)

=== core/data/hotplug/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

set(digikamhelperdir ${KDE_INSTALL_FULL_DATADIR}/digikam/utils)

#configure_file(digikam-download.desktop.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/digikam-download.desktop @ONLY)
#configure_file(digikam-gphoto2-camera.desktop.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/digikam-gphoto2-camera.desktop @ONLY)
#configure_file(digikam-mount-and-download.desktop.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/digikam-mount-and-download.desktop @ONLY)

configure_file(digikam-opencamera.desktop.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/digikam-opencamera.desktop @ONLY)

#install(FILES ${CMAKE_CURRENT_BINARY_DIR}/digikam-download.desktop
#              ${CMAKE_CURRENT_BINARY_DIR}/digikam-gphoto2-camera.desktop
#              ${CMAKE_CURRENT_BINARY_DIR}/digikam-mount-and-download.desktop
#        DESTINATION ${KDE_INSTALL_FULL_KSERVICESDIR}/ServiceMenus)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/digikam-opencamera.desktop DESTINATION ${KDE_INSTALL_FULL_DATADIR}/solid/actions)

if(NOT WIN32)
    install(PROGRAMS digikam-camera DESTINATION ${digikamhelperdir})
endif()

=== core/data/icons/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

add_subdirectory(actions)
add_subdirectory(apps)

=== debian/changelog ===
digikam (4:8.5.0-4ubuntu2) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.3 (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 29 Mar 2025 15:12:34 -0500

digikam (4:8.5.0-4ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add apparmor profile to fix userns:
      + Add debian/digikam-apparmor.
      + debian/control: Depend on apparmor, build depend on dh-apparmor and
        debhelper-compat (=13).
      + debian/rules:copy profile to tmp dir and invoke dh_apparmor.
      + debian/digikam.install: Install profile.

 -- Rik Mills <rikmills@kde.org>  Mon, 17 Feb 2025 12:15:33 +0000

digikam (4:8.5.0-4) unstable; urgency=medium

  * Release to unstable, now that opencv 4.10 is available.

 -- Steve M. Robbins <smr@debian.org>  Sat, 15 Feb 2025 18:33:17 -0600

digikam (4:8.5.0-3) experimental; urgency=medium

  * [e09457e] Update opencv dependency to 4.10 (fixes face detection).

 -- Steve M. Robbins <smr@debian.org>  Tue, 07 Jan 2025 22:33:00 -0600

digikam (4:8.5.0-2ubuntu3) plucky; urgency=medium

  * Rebuild against latest jpeg-xl

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 09 Feb 2025 17:21:44 -0500

digikam (4:8.5.0-2ubuntu2) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.2.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 05 Feb 2025 03:38:58 -0600

digikam (4:8.5.0-2ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add apparmor profile to fix userns:
      + Add debian/digikam-apparmor.
      + debian/control: Depend on apparmor, build depend on dh-apparmor and
        debhelper-compat (=13).
      + debian/rules:copy profile to tmp dir and invoke dh_apparmor.
      + debian/digikam.install: Install profile.

 -- Rik Mills <rikmills@kde.org>  Sun, 02 Feb 2025 12:31:00 +0000

digikam (4:8.5.0-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [a07b81c] Update standards-version; no changes
  * [5d2862d] Update patch forwarded dispositions.
  * [60e4a52] Declare digikam-data as Multi-Arch: foreign
  * [3d0b630] Suggest libimage-exiftool-perl.  Closes: #1055003.
  * [7fc56b2] Add version to imagemagick-6-common build-conflict because
    the imagemagick-7-common package now provides imagemagick-6-common
    to allow for smooth updates.  Closes: #1092312.

 -- Steve M. Robbins <smr@debian.org>  Tue, 07 Jan 2025 22:21:36 -0600

digikam (4:8.5.0-1ubuntu2) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.1.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 05 Dec 2024 02:18:49 -0600

digikam (4:8.5.0-1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add apparmor profile to fix userns:
      + Add debian/digikam-apparmor.
      + debian/control: Depend on apparmor, build depend on dh-apparmor and
        debhelper-compat (=13).
      + debian/rules:copy profile to tmp dir and invoke dh_apparmor.
      + debian/digikam.install: Install profile.

 -- Rik Mills <rikmills@kde.org>  Tue, 26 Nov 2024 12:24:52 +0000

digikam (4:8.5.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [df40dfc] Fix watch file to ensure the source package is selected.
  * [9fd25c5] New upstream version 8.5.0
  * [c3d97d8] Updates to dependencies and configuration.
  * [4ba829e] Updates to dependencies and configuration.

 -- Steve M. Robbins <smr@debian.org>  Sat, 16 Nov 2024 17:49:15 -0600

digikam (4:8.4.0-4ubuntu2) plucky; urgency=medium

  * No change rebuild against libexiv2-28

 -- Rik Mills <rikmills@kde.org>  Thu, 14 Nov 2024 13:04:31 +0000

digikam (4:8.4.0-4ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add apparmor profile to fix userns:
      + Add debian/digikam-apparmor.
      + debian/control: Depend on apparmor, build depend on dh-apparmor and
        debhelper-compat (=13).
      + debian/rules:copy profile to tmp dir and invoke dh_apparmor.
      + debian/digikam.install: Install profile.
  * Merged to fix FTBFS against ImageMagic 7.

 -- Rik Mills <rikmills@kde.org>  Fri, 08 Nov 2024 12:32:54 +0000

digikam (4:8.4.0-4) unstable; urgency=medium

  [ Steve Robbins ]
  * [9241918] Fix build with ImageMagick-7.  Closes: #1086354.

 -- Steve M. Robbins <smr@debian.org>  Thu, 31 Oct 2024 01:08:57 -0500

digikam (4:8.4.0-3ubuntu4) plucky; urgency=medium

  * No-change rebuild against libexiv2-28.

 -- Rik Mills <rikmills@kde.org>  Fri, 08 Nov 2024 11:41:30 +0000

digikam (4:8.4.0-3ubuntu3) plucky; urgency=medium

  * No-change rebuild against Qt 6.7.2 private-abi.

 -- Rik Mills <rikmills@kde.org>  Thu, 17 Oct 2024 17:51:12 +0100

=== debian/control ===
Source: digikam
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
Section: graphics
Priority: optional
Build-Depends: debhelper-compat (= 13),
# Build Helpers
               appstream,
               bison,
               cmake (>= 3.22.0),
               dh-apparmor,
               extra-cmake-modules (>= 5.91.0),
               flex,
               gphoto2,
               help2man,
# KDE Components
               libkf6calendarcore-dev,
               libkf6contacts-dev,
               libkf6filemetadata-dev,
               libkf6iconthemes-dev,
               libkf6kio-dev,
               libkf6notifyconfig-dev,
               libkf6service-dev,
               libkf6solid-dev,
               libkf6sonnet-dev,
               libkf6threadweaver-dev,
               libkf6windowsystem-dev,
               libkf6xmlgui-dev,
# Qt Libraries
               qt6-multimedia-dev,
               qt6-networkauth-dev,
               qt6-scxml-dev,
               qt6-svg-dev,
               qt6-webengine-dev,
# FFMPEG libraries
               libavcodec-dev, libavdevice-dev, libavfilter-dev, libavformat-dev, libavutil-dev, libpostproc-dev, libswresample-dev, libswscale-dev,
               libboost-graph-dev,
               libeigen3-dev (>= 3.1.2),
               libexiv2-dev (>= 0.27),
               libexpat1-dev | libexpat-dev,
               libheif-dev,
               libgphoto2-dev,
               libjpeg-dev, libjxl-dev,
               liblcms2-dev,
               liblensfun-dev,
               liblqr-1-0-dev,
               libmagick++-dev (>= 7),
               imagemagick-7.q16,
               libmarble-dev,
               libopencv-dev (>= 4.10),
               libpng-dev,
               libpulse-dev,
               libtiff-dev,
               libusb-1.0-0-dev [linux-any],
               libx265-dev,
               libxslt1-dev,
               libxml2-dev,
               libxv-dev,
               pkgconf,
               pkg-kde-tools (>= 0.15.21),
               portaudio19-dev
Build-Conflicts: libgraphicsmagick1-dev, imagemagick-6-common (<< 7.0),
                 libboost1.62-dev (<< 1.62.0+dfsg-4)
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/digikam
Vcs-Git: https://salsa.debian.org/debian/digikam.git
Homepage: http://www.digikam.org

Package: digikam-private-libs
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: private libraries for digiKam plugins
 This package contains private libraries to be used by digikam.
 .
 This has no use for anything else than digikam, since the libraries are
 installed in a private library path.

Package: digikam
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         digikam-private-libs (= ${binary:Version}),
         libqt6sql6-sqlite,
         libqt6sql6-mysql,
         digikam-data (= ${source:Version})
Recommends: www-browser,
            ffmpegthumbs
Suggests: digikam-doc,
          libimage-exiftool-perl,
          breeze-icon-theme,
          systemsettings,
          apparmor,
Description: digital photo management application for KDE
 Digital photo management program designed to import, organize, enhance, search
 and export your digital images to and from your computer.
 .
 It provides a simple interface which makes importing and organizing digital
 photographs a "snap". digiKam enables you to manage large numbers of
 digital photographs in albums and to organize these photographs for easy
 retrieval using tags (keywords), captions, collections, dates, geolocation
 and searches. It has many features for viewing, organizing, processing and
 sharing your images. Thus, digiKam is a formidable digital asset management
 (DAM) software including powerful image editing functions.
 .
 An easy-to-use camera interface is provided, that will connect to your
 digital camera and download photographs directly into digiKam albums.
 More than 1000 digital cameras are supported by the gphoto2 library.
 Of course, any media or card reader supported by your operating system
 will interface with digiKam.
 .
 digiKam incorporates a fast Image Editor with many image editing tools.
 You can use the Image Editor to view your photographs, comment and rate
 them, correct, enhance and alter them. The editing power can be easily
 extended by a set of plugins, the KDE Image Plugins Interface (manual)
 .
 While digiKam remains easy to use, it provides professional level features
 by the dozens. It is fully 16 bit enabled including all available plugins,
 supports RAW format conversion through libraw, DNG export and ICC color
 management work flow.

Package: showfoto
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         digikam-data (= ${source:Version}),
         digikam-private-libs (= ${binary:Version})
Recommends: dolphin
Description: image viewer/editor for KDE
 showFoto is the standalone image editor of the digiKam project.
 .
 It runs without digiKam images database support, but provides all Image Editor
 functions.

Package: digikam-data
Architecture: all
Depends: ${misc:Depends},
         opencv-data
Multi-Arch: foreign
Description: digiKam architecture-independant data
 Contains the significant amount of architecture-independent data that is
 shipped with digiKam.
 .
 It has been placed in an architecture all file to reduce space on the
 archives, rather than one copy for each architecture.

=== debian/rules ===
#!/usr/bin/make -f

PRIVATE_LIBDIR := /usr/lib/digikam
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Augment path to find gphoto2-config; workaround for #826166
export PATH := $(PATH):/usr/lib/$(DEB_HOST_MULTIARCH)/libgphoto2-dev/bin


%:
	dh $@ --with kf6

override_dh_auto_configure:
	dh_auto_configure --buildsystem=kf6 -- \
	  -DBUILD_WITH_QT6=on \
	  -DCMAKE_INSTALL_RPATH="$(PRIVATE_LIBDIR)" \
	  -DBUILD_TESTING=OFF \
	  -DDIGIKAMSC_COMPILE_DOC=on \
	  -DDIGIKAMSC_COMPILE_PO=on \
	  -DENABLE_MYSQLSUPPORT=ON \
	  -DENABLE_INTERNALMYSQL=ON \
	  -DENABLE_KFILEMETADATASUPPORT=ON \
	  -DENABLE_AKONADICONTACTSUPPORT=ON \
	  -DENABLE_MEDIAPLAYER=ON \
	  -DENABLE_APPSTYLES=ON 

#	help2man -n 'digital photo management application' --no-info obj-*/core/app/digikam > debian/man/digikam.1
#	help2man -n 'image viewer/editor' --no-info obj-*/core/showfoto/showfoto > debian/man/showfoto.1

override_dh_auto_install:
	dh_auto_install
	# remove development stuff: headers, cmake config files, pkg-config files, .so symlinks, static libs
	rm -rf --verbose debian/tmp/usr/include
	rm -rf --verbose debian/tmp/usr/share/kde4/apps/cmake
	rm -rf --verbose debian/tmp/usr/lib/cmake
	rm -rf --verbose debian/tmp/usr/lib/*/cmake
	rm -rf --verbose debian/tmp/usr/lib/pkgconfig
	find debian/tmp/usr/lib -type l -name '*.so' -exec rm --verbose {} \;
	# remove potentially conflicting oxygen icons in global icon theme
	rm -rf --verbose debian/tmp/usr/share/icons/oxygen
	# remove haar cascades, the versions in opencv-data will be used instead
	rm -rf --verbose debian/tmp/usr/share/kde4/apps/libkface/haarcascades
	# remove icons for non-installed test program
	rm -f --verbose debian/tmp/usr/share/icons/hicolor/*/apps/avplayer.*
	mkdir -p debian/tmp/etc/apparmor.d
	cp debian/digikam-apparmor debian/tmp/etc/apparmor.d/usr.bin.digikam
	dh_apparmor --profile-name=usr.bin.digikam -pdigikam

override_dh_installchangelogs:
	dh_installchangelogs -pdigikam ChangeLog
	dh_installchangelogs --remaining-packages

override_dh_install:
	dh_install
	dh_missing --fail-missing

override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/digikam-private-libs/$(PRIVATE_LIBDIR)

# auto tests require user interaction - override
override_dh_auto_test:
